// needs ArrayStack.java and Stack.java from 
//		http://www.skylit.com/javamethodsab/studentdisk/Ch03/
public class Brackets
{
	private static ArrayStack S;
	
	public static void main(String args[])
	{
		String str[] = {	"(12)",
							"x",
							"3*[2+7)",
							"[te(st}]ing",
							"[t(es)(ti)g123]" };

		for (int i=0; i<str.length; i++)
		{
			S = new ArrayStack();
			if ( BracketsMatch(str[i],0) )
				System.out.println("Bracket match: "+str[i]);
			else
				System.out.println("Bracket mismatch: "+str[i]);
		}
	}
	
	/**
	 * Returns true <==> L contains correctly 
	 *	matching brackets, [],{},().
	 */
	private static boolean BracketsMatch(String L, int i) {
		if (i == L.length()) 							// are we done?
			return S.isEmpty();							// is Stack clear?
		else
		{	
			char ch = L.charAt(i);						// next character
			if ( isOpenBracket(ch) )					// open bracket?
			{					
				S.push(new Character(ch));				// 	if so, push it...
				return  BracketsMatch(L,i+1);			//	...and keep going...
			}
			else {	
				if ( isCloseBracket(ch)) {				// close bracket?
					if (S.isEmpty()) 					// is there anything to pop?
						return false;					// :(
					else {
						char topch = ((Character)S.pop()).charValue();
						if (topch == '[' && ch == ']' ||// is it a matched pair?...
							topch == '(' && ch == ')' ||
							topch == '{' && ch == '}')
							return BracketsMatch(L,i+1);// if so, keep going...
						else
							return false;				// if not, :(
					}
				}
				else return BracketsMatch(L,i+1);		//if not a bracket, keep going
			}
		}

	}
		
	private static boolean isOpenBracket(char ch)
	{
		return (ch == '[' || ch == '(' || ch == '{');
	}
	private static boolean isCloseBracket(char ch)
	{
		return (ch == ']' || ch == ')' || ch == '}');
	}


}
				


